; This is the screen control file.  The commands in this file will tell
; Labtest what and where to place remarks on the user's screen.
;
; NOTE CHANGES FROM PREVIOUS VERSIONS!  The order of the keywords are no
; longer relevant.  This file is now divided into two sections, ANSI
; DEFINITION and RIP DEFINITION, each controlling how Labtest uses ANSI or
; RIP screens.
;
; ANSI Color codes are made up of foreground and background colors.
;
;            ANSI
;
;    Color     Value
;
;    Black       0
;    Blue        1
;    Green       2
;    Cyan        3
;    Red         4
;    Magenta     5
;    Brown       6
;    Grey        7
;
; For ANSI:
; To make a color bright, add 8 to the foreground color value
; To make a color blinking, add 8 to the background color value
; For example, to make the Working_Text color bright green on a black
; background with blinking on, you would use a value of 10 (Green is 2+8
; for bright) for the foreground, and a value of 8 (Black is 0+8 for
; blinking) for the background.
;
; The Working_Text will be displayed during the actual processing of
; each phase of Labtest.  It will be displayed in place of the Pass or
; Fail text at the given coordinates for each phase.  The Row and Col
; for Working_Text is ignored, but should be set to 1, not 0.
;
; To disable displaying of an item, set the row and col to 0.
;
; The #Begin Ansi definition marks the beggining of the Ansi Screen Control
; section.

#Begin Ansi definition

; Keyword                 Text      Row   Col   Fore  Back
Working_Text              ?         1      1     10     9
File_Name_Display         @         14     19    11     1
File_Date_Pass                     3      46    10     1
File_Date_Fail                     3      46    12     1
HackReport_Pass                    4      46    10     1
HackReport_Fail                    4      46    12     1
Jpg/Gif_Test_Pass                  5      46    10     1
Jpg/Gif_Test_Fail                  5      46    12     1
Unpack_Pass                        6      46    10     1
Unpack_Fail                        6      46    12     1
FileIdDiz_Pass                     7      46    10     1
FileIdDiz_Fail                     7      46    12     1
Imbedded_Files_Pass                8      46    10     1
Imbedded_Files_Fail                8      46    10     1
Remove_Unwanted_Pass               9      46    10     1
Remove_Unwanted_Fail               9      46    12     1
Add_Files_Pass                     10     46    10     1
Add_Files_Fail                     10     46    12     1
Virus_Scan_Pass                    11     46    10     1
Virus_Scan_Fail                    11     46    12     1
Repack_Pass                        12     46    10     1
Repack_Fail                        12     46    12     1
Add_Comment_Pass                   13     46    10     1
Add_Comment_Fail                   13     46    12     1
Remove_Work_Dir_Pass               14     46    10     1
Remove_Work_Dir_Fail               14     46    12     1
Update_RA_Pass                     15     46    10     1
Update_RA_Fail                     15     46    12     1
;
; End ANSI definition
;
; The #Begin Rip definition marks the beggining of the Rip Screen Control
; section.  This is optional.

#Begin Rip definition

; For Rip:
;
; For simplicity sake, Labtest will display the text in the Default
; (8x8) font, using a magnification factor of 1.  Refere to your
; RIPSCRIP document for information on Rip colors and numbering system.
;
; RIP color codes consist of only a foreground color.  Below
; is a table of color codes that you can use:
;
; Note that we are now using decimal numbers vice the RIP meganumber style!
;
;               Color     Value   Color           Value
;               Black       0
;               Blue        1     L. Blue           9
;               Green       2     L. Green         10
;               Cyan        3     L. Cyan          11
;               Red         4     L. Red           12
;               Magenta     5     L. Magenta       13
;               Brown       6     Yellow           14
;               L. Grey     7     White            15
;               D. Grey     8
;
; Row/Column coordinates are based on the EGA screen of 640 x 350.
; Row values range from 1 to 350.  Column values range from 1 to 640.
;
; You may use EITHER the RIP 'meganumber' coordinates as used by RIP
; or use their decimal equivelants.  If you elect to use the RIP numbering
; system, precede each of your numbers with an 'm' as seen below.  If
; the number is decimal, do not precede it with anything, just the number.
; This tells Labtest wheter conversion is needed or not.
;
; To display the filename in your ripscreen, use the macro, @FILE@
; to tell labtest where to display the filename.  When you draw your rip
; screen, place the @FILE@ macro where you want it to be displayed.
; The filename will be displayed in the current text style, size, and colors.
;
; Keyword                 Text      Row   Col  Color
Working_Text              Working   1     1    14
File_Date_Pass            Ok       m1X   m8B   10
File_Date_Fail            Old      m1X   m8B   12
HackReport_Pass           Ok       m27   m8B   10
HackReport_Fail           Hack!    m27   m8B   12
Unpack_Pass               Ok       m2R   m8B   10
Unpack_Fail               Fail     m2R   m8B   12
Imbedded_Files_Pass       Ok       m3B   m8B   10
Imbedded_Files_Fail       Fail     m3B   m8B   10
Remove_Unwanted_Pass      Ok       m3L   m8B   10
Remove_Unwanted_Fail      Fail     m3L   m8B   12
Add_Files_Pass            Ok       m3V   m8B   10
Add_Files_Fail            Fail     m3V   m8B   12
Virus_Scan_Pass           Ok       m45   m8B   10
Virus_Scan_Fail           Ouch!    m45   m8B   12
Repack_Pass               Ok       m4F   m8B   10
Repack_Fail               Fail     m4F   m8B   12
Add_Comment_Pass          Ok       m4P   m8B   10
Add_Comment_Fail          Fail     m4P   m8B   12
Remove_Work_Dir_Pass      Ok       m4Z   m8B   10
Remove_Work_Dir_Fail      Fail     m4Z   m8B   12
JPG/GIF_Test_Pass         Ok       m2H   m8B   10
JPG/GIF_Test_Fail         Ugly     m2H   m8B   12
Update_RA_Pass            Ok       m5A   m8B   10
Update_RA_Fail            Fail     m5A   m8B   12
FileIdDizPass             Ok       m31   m8B   10
FileIdDizFail             Fail     m31   m8B   12
;
; End RIP definition
